
// for php/tags1.php

var text_undo = new Array();
var tags_type = 0;
var tags_types = new Array(
	new Array('[!','!]'),
	new Array('[',']'),
	new Array('{','}'),
	new Array('@','@')
	);
var tags_list = new Array(
	new Array('B',1),
	new Array('I',1),
	new Array('U',1),
	new Array('BR',0),
	new Array('PRE',1),
	new Array('P',1)
	);
var tags2_list = new Array(
	new Array('C','tcolor'),
	new Array('FRM','tcolor'),
	new Array('LPAD','tpad'),
	new Array('FRMB','tcolor')
	);

function show_undolevel()
{
    var lable = document.getElementById('lable_undo');

    lable.innerHTML = text_undo.length;
}

function textarea_fix()
{
    var undo = new Array();
    var textarea = document.formpost.text;

    undo[0] = textarea.value;
    if (typeof(textarea.caretPos) != "undefined" && textarea.createTextRange)
    {
	undo[1] = textarea.caretPos;
    }
    else if (typeof(textarea.selectionStart) != "undefined")
    {
	undo[1] = new Array(textarea.selectionStart,textarea.selectionEnd,textarea.scrollTop);
    }
    text_undo.push(undo);
    show_undolevel()
}

function textarea_replace(text)
{
    var undo = new Array();
    var textarea = document.formpost.text;
    
    undo[0] = textarea.value;
    if (typeof(textarea.caretPos) != "undefined" && textarea.createTextRange)
    {
	var caretPos = textarea.caretPos;

	undo[1] = caretPos;
	caretPos.text = caretPos.text.charAt(caretPos.text.length - 1) == " " ? text + " " : text;
	caretPos.select();
    }
    else if (typeof(textarea.selectionStart) != "undefined")
    {
	var begin = textarea.value.substr(0, textarea.selectionStart);
	var end = textarea.value.substr(textarea.selectionEnd);
	var scrollPos = textarea.scrollTop;

	undo[1] = new Array(textarea.selectionStart,textarea.selectionEnd,scrollPos);
	textarea.value = begin + text + end;

	if (textarea.setSelectionRange)
	{
	    textarea.focus();
	    textarea.setSelectionRange(begin.length + text.length, begin.length + text.length);
	}
	textarea.scrollTop = scrollPos;
    }
    else
    {
	textarea.value += text;
	textarea.focus(textarea.value.length - 1);
    }
    text_undo.push(undo);
    show_undolevel()
}

function textarea_surround(text1, text2)
{
    var undo = new Array();
    var textarea = document.formpost.text;
    
    undo[0] = textarea.value;
    if (typeof(textarea.caretPos) != "undefined" && textarea.createTextRange)
    {
	var caretPos = textarea.caretPos;

	undo[1] = caretPos;
	caretPos.text = caretPos.text.charAt(caretPos.text.length - 1) == ' ' ? text1 + caretPos.text + text2 + ' ' : text1 + caretPos.text + text2;
	caretPos.select();
    }
    else if (typeof(textarea.selectionStart) != "undefined")
    {
	var begin = textarea.value.substr(0, textarea.selectionStart);
	var selection = textarea.value.substr(textarea.selectionStart, textarea.selectionEnd - textarea.selectionStart);
	var end = textarea.value.substr(textarea.selectionEnd);
	var newCursorPos = textarea.selectionStart;
	var scrollPos = textarea.scrollTop;

	undo[1] = new Array(textarea.selectionStart,textarea.selectionEnd,scrollPos);
	textarea.value = begin + text1 + selection + text2 + end;

	if (textarea.setSelectionRange)
	{
	    if (selection.length == 0)
		textarea.setSelectionRange(newCursorPos + text1.length, newCursorPos + text1.length);
	    else
		textarea.setSelectionRange(newCursorPos, newCursorPos + text1.length + selection.length + text2.length);
	    textarea.focus();
	}
	textarea.scrollTop = scrollPos;
    }
    else
    {
	textarea.value += text1 + text2;
	textarea.focus(textarea.value.length - 1);
    }
    text_undo.push(undo);
    show_undolevel()
}

function textarea_undo()
{
    var undo;
    var textarea = document.formpost.text;
    
    if(text_undo.length == 0) return;
    undo = text_undo.pop();
    textarea.value = undo[0];
    show_undolevel()
    if (typeof(textarea.caretPos) != "undefined" && textarea.createTextRange)
    {
	undo[1].select();
    }
    else if (typeof(textarea.selectionStart) != "undefined")
    {
	textarea.selectionStart = undo[1][0];
	textarea.selectionEnd = undo[1][1];
	if (textarea.setSelectionRange)
	{
	    textarea.focus();
	    textarea.setSelectionRange(undo[1][0],undo[1][1]);
	}
	textarea.scrollTop = undo[1][2];
    }
    else
    {
	textarea.focus(textarea.value.length - 1);
    }
}

function tags_select()
{
    tags_type = document.formpost.tagstyle.value;
}

function tag_insert(tag)
{
    var i;
    var bl = tags_types[tags_type][0];
    var br = tags_types[tags_type][1];

    for(i=0; i < tags_list.length; i++)
    {
	if(tags_list[i][0] == tag)
	{
	    if(tags_list[i][1] == 1)
	    {
		textarea_surround(bl + tag + br, bl + '/' + tag + br);
	    }
	    else
	    {
		textarea_replace(bl+tag+br);
	    }
	    break;
	}
    }
    for(i=0; i < tags2_list.length; i++)
    {
	if(tags2_list[i][0] == tag)
	{
	    var value = document.formpost[tags2_list[i][1]].value;
	    textarea_surround(bl + tag + '=' + value + br, bl + '/' + tag + br);
	}
    }
}
