<?php

include("defs.php");

class tags1
{
    var $prefix;
    var $postfix;
    var $close_char = '/';
    var $re_bracket = '@';
    var $img_path = '/images/img';
    var $img_exts = 'png|jpg|jpeg|gif';
    var $file_path = '/files/file';
    var $file_exts = 'rar,zip,gz,bz2';
    var $tag_styles = array(
	array('[!','!]'),
	array('[',']'),
	array('{','}'),
	array('@','@')
	);
    var $tag_style = 0;
    var $nl2br_style;

    function tags1()
    {
	$this->set_tag_style(0);
	$this->set_nl2br('');
    }

    function set_tag_style($style)
    {
	if($style >= count($this->tag_styles) || $style < 0) $style = 0;
	$this->tag_style = $style;
	list($this->prefix,$this->postfix) = $this->tag_styles[$style];
    }

    function set_nl2br($style)
    {
	if(!preg_match('/^(?:\d+\+?|pre)$/i',$style)) $style = '0';
	$this->nl2br_style = $style;
    }

    function encode($str)
    {
	$p1 = preg_quote($this->prefix,$this->re_bracket);
	$p2 = preg_quote($this->postfix,$this->re_bracket);
	$cl = preg_quote($this->close_char,$this->re_bracket);
/*
*  =>
*	[0] - PCRE   
*	[1] -    
*	[2] -  HTML-  
*	[3] -  HTML-   -   sprintf()
*	[4] -  HTML-
*
*  :
*
*  1)    ,     $codes   .
*  2)     [4].
*  3)   [0] ,   [2].
*  4)     ,       [0].
*	       .
*  5)   [1] , :
*	)   -  [3];
*	)   -  [2].
*  6)   [1]    , :
*	)   -  [3];
*	)   -  [3]    .
*
*/
	$codes = array(
	    'B'=>array('','','<B>','','</B>'),
	    'I'=>array('','','<I>','','</I>'),
	    'U'=>array('','','<U>','','</U>'),
	    'H1'=>array('','','<H1>','','</H1>'),
	    'H2'=>array('','','<H2>','','</H2>'),
	    'H3'=>array('','','<H3>','','</H3>'),
	    'H4'=>array('','','<H4>','','</H4>'),
	    'H5'=>array('','','<H5>','','</H5>'),
	    'H6'=>array('','','<H6>','','</H6>'),
	    'C'=>array('[a-zA-Z]+|#[[:alnum:]]{6}','black','','<FONT COLOR="%s">','</FONT>'),
	    'S'=>array('[-+]?\d+','+1','','<FONT SIZE="%s">','</FONT>'),
	    'PRE'=>array('','','<PRE>','','</PRE>'),
	    'P'=>array('RIGHT|LEFT|CENTER|JUSTIFY','','<P>','<P ALIGN="%s">','</P>'),
	    'BR'=>array('','','','<BR>',''),
	    'OL'=>array('1|A|a|I|i','','<OL>','<OL TYPE="%s">','</OL>'),
	    'UL'=>array('DISC|SQUARE|CIRCLE','','<UL>','<UL TYPE="%s">','</UL>'),
	    'LI'=>array('[0-9]+','','<LI NUMBER="%s">','<LI>','</LI>'),
	    'FRM'=>array('[a-zA-Z]\w*|#[[:alnum:]]{6}','',
		'<TABLE BORDER="0" CELLPADDING="8"><TR><TD>',
		'<TABLE BORDER="0" BGCOLOR="%s" CELLPADDING="8"><TR><TD>',
		'</TD></TR></TABLE>'),
	    'FRMB'=>array('[a-zA-Z]\w*|#[[:alnum:]]{6}','',
		'<TABLE BORDER="1" FRAME="thin" RULES="none" CELLPADDING="8"><TR><TD>',
		'<TABLE BORDER="1" FRAME="thin" RULES="none" CELLPADDING="8" BGCOLOR="%s"><TR><TD>',
		'</TD></TR></TABLE>'),
	    'LPAD'=>array('\d+(?:%)?','10%','',
		'<TABLE BORDER="0" WIDTH="100%%" CELLSPACING="0"><TR><TD WIDTH="%s">&nbsp;<TD>',
		'</TD></TR></TABLE>'),
	    'IMG'=>array("\d+",'','','<IMG SRC="'.$this->img_path.'%s">',''),
	    'IMGT'=>array("\d+",'','','<IMG ALIGN="TOP" SRC="'.$this->img_path.'%s">',''),
	    'IMGB'=>array("\d+",'','','<IMG ALIGN="BOTTOM" SRC="'.$this->img_path.'%s">',''),
	    'IMGL'=>array("\d+",'','','<IMG ALIGN="LEFT" SRC="'.$this->img_path.'%s">',''),
	    'IMGM'=>array("\d+",'','','<IMG ALIGN="MIDDLE" SRC="'.$this->img_path.'%s">',''),
	    'IMGR'=>array("\d+",'','','<IMG ALIGN="RIGHT" SRC="'.$this->img_path.'%s">',''),
	    'FILE'=>array("\d+",'','','<A HREF="'.$this->file_path.'%s">','</A>')
	    );

	$out = '';
	$re = $this->re_bracket."($p1(?:\w+|\w+=[^$p2]+?|$cl\w+)$p2)".$this->re_bracket.'i';
	$parts = preg_split($re,$str,0,PREG_SPLIT_DELIM_CAPTURE);
	foreach($parts as $part)
	{
	    $re = $this->re_bracket."^$p1($cl)?(\w+)=?(.*)?$p2\$".$this->re_bracket.'i';
	    if(preg_match($re,$part,$a))
	    {
		if(isset($codes[strtoupper($a[2])]))
		{
		    $v = $codes[strtoupper($a[2])];
		    if($a[1] != '')
		    { // close tag
			$part = $v[4];
		    }
		    else if($v[0] == '')
		    { // no attr
			$part = $v[2];
		    }
		    else if($a[3] != '' && !preg_match($this->re_bracket."^$v[0]\$".$this->re_bracket.'i',$a[3]))
		    { // bad attribute
			$part = '';
		    }
		    else if($v[1] == '')
		    { // w/o default attr
			if($a[3] == '') $part = $v[2];
			else $part = sprintf($v[3],$a[3]);
		    }
		    else
		    {
			if($a[3] == '') $part = sprintf($v[3],$v[1]);
			else $part = sprintf($v[3],$a[3]);
		    }
		}
	    }
	    $out .= $part;
	}
	switch(strtoupper($this->nl2br_style))
	{
	case "PRE":
	    $a = preg_split('/(<PRE>.*?<\/PRE>)/is',$out,0,PREG_SPLIT_DELIM_CAPTURE);
	    $out = '';
	    foreach($a as $k=>$v)
	    {
//echo("DEBUG: $k: ".htmlspecialchars($v)."<BR>");
		if($k%2)
		{
		    $out .= $v;
		}
		else
		{
		    $out .= str_replace("\n","<BR>\n",$v);
		}
	    }
	    break;
	case "0":
	    break;
	case "1":
	    $out = str_replace("\n","<BR>\n",$out);
	    break;
	case "2":
	    $out = str_replace("\n\n","<BR>\n",$out);
	    break;
	case "3":
	    $out = str_replace("\n\n\n","<BR>\n",$out);
	    break;
	default: // n+
	    $out = preg_replace("/\n+/","<BR>\n",$out);
	}
	return $out;
    }

    function place_header()
    {
	global $path_js;

	return '<SCRIPT TYPE="text/javascript" SRC="'.$path_js.'tags1.js"></SCRIPT>';
    }

    function place_script()
    {
	return '';
    }

    function show_pannel()
    {
	$out = '<TABLE BORDER="1" FRAME="thin" RULES="thin" CELLPADDING="8"><TR><TD>'.
	    '<CENTER><B>Format&nbsp;pannel</B></CENTER>'.
	    '</TD></TR><TR><TD>'.
	    '<TABLE BORDER="0" CELLPADDING="0">'.
	    "<TR><TD>Choose tag format:</TD><TD><SELECT NAME=\"tagstyle\" ONCHANGE=\"tags_select();\">";
	foreach($this->tag_styles as $k=>$v)
	{
	    if($k == $this->tag_style) $out .= "<OPTION SELECTED VALUE=\"$k\">$v[0]tag$v[1]</OPTION>";
	    else $out .= "<OPTION VALUE=\"$k\">$v[0]tag$v[1]</OPTION>";
	}
	$out .= '</SELECT></TD></TR>'.
	    "<TR><TD>Choose color:</TD><TD><SELECT NAME=\"tcolor\">";
	$colors = array('black','red','green','yellow','blue','magenta','cyan','white');
	foreach($colors as $c)
	{
	    $out .= "<OPTION VALUE=\"$c\">$c</OPTION>";
	}
	$out .= '</SELECT></TD></TR>'.
	    "<TR><TD>Choose padding step:</TD><TD><SELECT NAME=\"tpad\">";
	for($i=5; $i <= 70; $i+=5)
	{
	    $out .= "<OPTION VALUE=\"$i%\">$i%</OPTION>";
	}
	$out .= '</SELECT></TD></TR>'.
	    '<TR><TD>Undo count:</TD><TD><SPAN ID="lable_undo">0</SPAN></TD></TR>'.
	    '</TABLE>'.
	    '</TD></TR><TR><TD>'.
	    "<A HREF=\"javascript:void(0);\" ONCLICK=\"textarea_undo(); return false;\">Undo</A>&nbsp;&nbsp; ".
	    "<A HREF=\"javascript:void(0);\" ONCLICK=\"textarea_fix(); return false;\">Fix</A>&nbsp;&nbsp; ".
	    "<A HREF=\"javascript:void(0);\" ONCLICK=\"tag_insert('B'); return false;\">Bold</A>&nbsp;&nbsp; ".
	    "<A HREF=\"javascript:void(0);\" ONCLICK=\"tag_insert('I'); return false;\">Italic</A>&nbsp;&nbsp; ".
	    "<A HREF=\"javascript:void(0);\" ONCLICK=\"tag_insert('U'); return false;\">Underline</A>&nbsp;&nbsp; ".
	    "<A HREF=\"javascript:void(0);\" ONCLICK=\"tag_insert('BR'); return false;\">Break&nbsp;line</A>&nbsp;&nbsp; ".
	    "<A HREF=\"javascript:void(0);\" ONCLICK=\"tag_insert('P'); return false;\">Paragraph</A>&nbsp;&nbsp; ".
	    "<A HREF=\"javascript:void(0);\" ONCLICK=\"tag_insert('LPAD'); return false;\">Padding</A>&nbsp;&nbsp; ".
	    "<A HREF=\"javascript:void(0);\" ONCLICK=\"tag_insert('PRE'); return false;\">Formated&nbsp;text</A>&nbsp;&nbsp; ".
	    "<A HREF=\"javascript:void(0);\" ONCLICK=\"tag_insert('C'); return false;\">Color</A>&nbsp;&nbsp; ".
	    "<A HREF=\"javascript:void(0);\" ONCLICK=\"tag_insert('FRM'); return false;\">Colored&nbsp;frame</A>&nbsp;&nbsp; ".
	    "<A HREF=\"javascript:void(0);\" ONCLICK=\"tag_insert('FRMB'); return false;\">Colored&nbsp;frame&nbsp;with&nbsp;border</A>".
	    '</TD></TR></TABLE>';
	return $out;
    }
}
?>